#!/bin/bash
set -euo pipefail
set -x
WD=$(mktemp -d)
cleanup (){
  rm -rf "${WD}"
}
trap 'cleanup' EXIT
form_dir="$1"

SCRIPTDIR=$(readlink -f "${BASH_SOURCE[0]%/*}")

declare -a contacts
update_members(){
	name="${contacts[$1-1]}"
	email="${2}"
	MEMBERS["$email"]="${name}"
}
update_signup(){
	name="${contacts[$1-1]}"
	email="${2}"
	for key in "${!MEMBERS[@]}"; do
		[ "${key}" == "${email}" ] && return
	done
	SIGNUP["$email"]="${name}"
}
for group in cropswap cropswap-members; do
	declare -A MEMBERS=()
	# Define an array of contacts (name and email pairs)
	#
	# Reads files in $form_dir with structure like
	#
	#  Name: Som E. Name
	#  Email: address@example.com
	mapfile -t -c 2 -C update_members contacts < <("${SCRIPTDIR}/gdbm-iter.py" "/var/mail/maildrop/${group}@shandan.one/mlist")
	unset contacts

	declare -A SIGNUP=()
	mapfile -t -c 2 -C update_signup contacts < <(find ${form_dir} -type f -name "*.txt" -exec awk -F ":" '
/Name:/ { print substr($2,2) OFS }
/Email:/ { print substr($2,2) OFS }
' {} \;)

	for email in "${!SIGNUP[@]}"; do
		echo "${SCRIPTDIR}/cropswap-register.sh" "${group}@shandan.one" "${SIGNUP["$email"]}" "$email" NONE
	done
done
