#!/usr/bin/env python3
# depends (debian) python3-gdbm
import dbm
import sys
#mlist, alist, slist = sys.argv[1:4]
mlist, slist = sys.argv[1:3]

def gdbm_iter_keys(dbpath):
    with dbm.open(dbpath, 'r') as db:
        k = db.firstkey()
        while k is not None:
            yield k, db.get(k)
            k = db.nextkey(k)

#admins = filter(lambda x: x[1].lower() == 'admin', gdbm_iter_keys(alist) if alist else [])
#subscribed = filter(lambda x: x[1].lower() == 'subscribe', gdbm_iter_keys(slist))

SUBSCRIBED = {
  'admin',
  'subscribe',
}

members = filter(lambda x: x[1], gdbm_iter_keys(mlist))
subscribed = set(map(lambda x: x[0], filter(
    lambda x: x[1].decode('utf-8').lower() in SUBSCRIBED,
    gdbm_iter_keys(slist)
)))

for email, alias in {
    k: v for k,v in members if k in subscribed
}.items():
    print(alias.decode('utf-8'))
    print(email.decode('utf-8'))

