#!/usr/bin/env python3
import sys
import email

mailgroup = sys.argv[1]
try:
    with open(f'/opt/cropswap/{mailgroup}/banner.html', 'rb') as f:
        html = f.read().decode("utf-8")
    with open(f'/opt/cropswap/{mailgroup}/banner.txt', 'rb') as f:
        txt = f.read().decode("utf-8")
except FileNotFoundError:
    html = ''
    txt = ''

m = email.message_from_bytes(sys.stdin.buffer.read())

INJECTED = {
    'text/plain': False,
    'text/html': False,
}

def inject(m):
    c = m.get_content_type()
    e = m.get('Content-Transfer-Encoding','').lower()
    payload = m.get_payload(decode=True).decode("utf-8")
    if c == 'text/plain' and txt not in payload:
        payload = payload + f"""
{txt}
"""
    if c == 'text/html':
        payload = payload.replace(html, '')
        if '</body>' in payload:
            payload = payload.replace('</body>', f'{html}</body>')
        else:
            payload += f'{html}'

    if e == 'quoted-printable':
        encode = email.encoders.encode_quopri
    elif e in ('7bit', '8bit'):
        encode = email.encoders.encode_7or8bit
    elif e == 'base64':
        encode = email.encoders.encode_base64
    else:
        encode = email.encoders.encode_noop
    m.set_payload(payload.encode("utf-8"))
    encode(m)
    m.set_charset("utf-8")

def visit(m):
    c = m.get_content_type()
    if c in ('text/plain', 'text/html'):
        if INJECTED[c]: return
        inject(m)
        INJECTED[c] = True

for _m in m.walk():
     visit(_m)

sys.stdout.buffer.write(m.as_bytes())
