#!/bin/bash
set -euo pipefail
export DEBUG=1
export TEST=1
MAILDROPDIR=$(mktemp -d)
cleanup (){
	rm -rf "$MAILDROPDIR"
}
trap cleanup EXIT

export MAILDROPDIR

SCRIPTDIR=$(readlink -e "${BASH_SOURCE[0]%/*}/../")
cd "$MAILDROPDIR"

#
# TEST cropswap@shandan.one
mkdir cropswap@shandan.one
${SCRIPTDIR}/cropswap-register.sh cropswap@shandan.one "Member" "member1@mail.com" NONE &>/dev/null
${SCRIPTDIR}/cropswap-register.sh cropswap@shandan.one "Member" "member2@mail.com" "" &>/dev/null
${SCRIPTDIR}/cropswap-register.sh cropswap@shandan.one "Organizer" organizer1@mail.com "admin" &>/dev/null
${SCRIPTDIR}/cropswap-register.sh cropswap@shandan.one "Organizer" organizer2@mail.com "admin" &>/dev/null

set -x
maildrop -funregistered@mail.com < ${SCRIPTDIR}/tests/cropswap@shandan.one/from-unregistered.eml 1>forward.out 2>forward.err #|| cat forward.err && exit 1
grep '^From: A. Person <unregistered@mail.com>$' < forward.out
! grep '^To: A. Person <unregistered@mail.com>$' < forward.out
grep '^To: Organizer <organizer1@mail.com>$' < forward.out
grep '^To: Organizer 1 <organizer2@mail.com>$' < forward.out
! grep '^To: Member <member1@mail.com>$' < forward.out
! grep '^To: Member 1 <member2@mail.com>$' < forward.out
grep '^Subject: \[Crop Swap Query\] .*$' < forward.out

maildrop -fmember1@mail.com < ${SCRIPTDIR}/tests/cropswap@shandan.one/from-member.eml 1>forward.out 2>forward.err
grep '^From: Member <cropswap@shandan.one>$' < forward.out
! grep '^To: Member <member1@mail.com>$' < forward.out
grep '^To: Organizer <organizer1@mail.com>$' < forward.out
grep '^To: Organizer 1 <organizer2@mail.com>$' < forward.out
grep '^Subject: \[Crop Swap Query\] .*$' < forward.out

maildrop -forganizer1@mail.com < ${SCRIPTDIR}/tests/cropswap@shandan.one/from-organizer-to-member.eml 1>forward.out 2>forward.err
grep '^From: Organizer <cropswap@shandan.one>$' < forward.out
! grep '^To: Organizer <organizer1@mail.com>$' < forward.out
! grep '^To: Organizer 1 <organizer2@mail.com>$' < forward.out
! grep '^To: Member <member1@mail.com>$' < forward.out
grep '^To: Member 1 <member2@mail.com>$' < forward.out
grep '^Subject: \[Crop Swap Notice\] .*$' < forward.out

maildrop -forganizer2@mail.com < ${SCRIPTDIR}/tests/cropswap@shandan.one/from-organizer.eml 1>forward.out 2>forward.err
grep '^From: Organizer 1 <cropswap@shandan.one>$' < forward.out
! grep '^To: Organizer 1 <organizer2@mail.com>$' < forward.out
grep '^To: Organizer <organizer1@mail.com>$' < forward.out
grep '^To: Member <member1@mail.com>$' < forward.out
grep '^To: Member 1 <member2@mail.com>$' < forward.out
grep '^Subject: \[Crop Swap Notice\] .*$' < forward.out
